#include <iostream>

using namespace std;

int main()
{
    int n;
    int m;
    cin >> n >> m;
    int aniz[m];
    int bniz[m];
    int tniz[m]; // 1 = led ; 0 = no led


    for(int i = 0; i < m; i++) {
        cin >> aniz[i] >> bniz[i] >> tniz[i];
        if(aniz[i] > bniz[i]) {
            int tmp = aniz[i];
            aniz[i] = bniz[i];
            bniz[i] = tmp;
        }
    }

    int u; // mika
    int v; // laza
    cin >> u >> v;
    int masina = 0;
    bool masinast = false;

    if (u < v) {
        for(int i = 0; i < m; i++) {
            if bniz[i] == v {


                if (tniz[i] == 1) {
                    masina++;
                    if (masinast == false) masinast = true;
                }
                else if(tniz[i == 0]) {
                    masina++;
                    if(masinast == true) masinast = false
                }
            }
        }
    }
    else if (v < u) {
            if aniz[i] == v {


                if (tniz[i] == 1) {
                    masina++;
                    if (masinast == false) masinast = true;
                }
                else if(tniz[i == 0]) {
                    masina++;
                    if(masinast == true) masinast = false
                }
            }

    }
    else cout << 0 << endl;



    return 0;
}